%global _real_name installer
# VERSION is subbed out during rake srpm process
%global realversion 0.0.2-742
%global rpmversion  0.0.2.742
%global app_dir     /opt/puppet/share/%{_real_name}

%define _bundle     /opt/puppet/bin/bundle
%define _path       %{_bindir}:$PATH
%define _logdir     /var/log/%{name}

AutoReqProv:        0
Name:               pe-%{_real_name}
Version:            %{rpmversion}
Release:            1.pe%{?dist}
Summary:            Web installer interview

License:            PL Commercial
URL:                http://puppetlabs.com/puppet/puppet-enterprise
Source0:            %{name}-%{realversion}.tar.gz

BuildRoot:          %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Group:              Development/Languages

BuildRequires:      pe-bundler
BuildRequires:      pe-rubygem-rake

Requires:           pe-ruby
Requires:           pe-bundler


%description
Web installer interview

%prep
%setup -q -n %{name}-%{realversion}

%build
%install
rm -rf $RPM_BUILD_ROOT

# Setup directories
install -d -m0755 $RPM_BUILD_ROOT%{app_dir}
install -d -m0755 $RPM_BUILD_ROOT%{app_dir}/vendor
install -p -d -m0755 $RPM_BUILD_ROOT%{_logdir}

# Install the development gemset
PATH=%{_path} %{_bundle} install --local --deployment --path $RPM_BUILD_ROOT%{app_dir}/vendor --without testing

# Build the precomiled assets and remove the installed gems
/opt/puppet/bin/rake -r bundler/setup build
rm -r $RPM_BUILD_ROOT%{app_dir}/vendor

# Install the production gemset
PATH=%{_path} %{_bundle} install --local --deployment --path $RPM_BUILD_ROOT%{app_dir}/vendor --without development testing
# Finally, we can remove the cached gems since we're not using them for install again
rm -r vendor/cache
# Since we don't want the installer's BUNDLE_PATH to be set to /tmp/builddir/..., we have to set it manually here
%{_bundle} config --local PATH %{app_dir}/vendor

mkdir -p $RPM_BUILD_ROOT%{app_dir}/assets
cp -pr .bundle $RPM_BUILD_ROOT%{app_dir}
cp -pr helpers $RPM_BUILD_ROOT%{app_dir}
cp -pr lib $RPM_BUILD_ROOT%{app_dir}
cp -pr models $RPM_BUILD_ROOT%{app_dir}
cp -pr assets/i18n $RPM_BUILD_ROOT%{app_dir}/assets
cp -pr public $RPM_BUILD_ROOT%{app_dir}
cp -pr vendor $RPM_BUILD_ROOT%{app_dir}
cp -pr views $RPM_BUILD_ROOT%{app_dir}
cp -pr app.rb $RPM_BUILD_ROOT%{app_dir}
cp -pr config.ru $RPM_BUILD_ROOT%{app_dir}
cp -pr Gemfile $RPM_BUILD_ROOT%{app_dir}
cp -pr Gemfile.lock $RPM_BUILD_ROOT%{app_dir}
chmod uog+Xr -R $RPM_BUILD_ROOT%{app_dir}
find $RPM_BUILD_ROOT%{app_dir} -type f | xargs chmod 644
chmod u+x $RPM_BUILD_ROOT%{app_dir}/app.rb
chmod -R u+x $RPM_BUILD_ROOT%{app_dir}/vendor/ruby/1.9.1/bin


# Ensure the ruby referenced is opt/puppet/bin
for file in `find $RPM_BUILD_ROOT%{app_dir} -type f`; do
  sed -i -e '1s,^#!.*ruby$,#!/opt/puppet/bin/ruby,' $file
done

# Clean up cruft from building gems
find $RPM_BUILD_ROOT%{app_dir}/vendor/ruby/1.9.1/gems -name Makefile -or -name generator.o | xargs -r rm -f

# Strip debug symbols from lame gems
for file in `find  $RPM_BUILD_ROOT%{app_dir}/vendor/ruby/1.9.1/gems -name '*.o' -or -name '*.so'`; do
    strip --strip-debug $file
done

%files
%{app_dir}
%dir %{_logdir}

%changelog

* Wed Mar 25 2015 Puppet Labs Release <info@puppetlabs.com> - 0.0.2.742-1
- Build for 0.0.2-742
